<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/12/2004 *
 * ================                             Last change: 04/18/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-admins_add.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Add new administrator account                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Neues Administrator-Account anlegen              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Display form is default
$FORM = true;

if ((REQUEST_ISSET_POST(('add'))) && (REQUEST_ISSET_POST(('login'))) && (REQUEST_ISSET_POST(('email'))) && (REQUEST_ISSET_POST(('pass1'))) && (REQUEST_ISSET_POST(('pass2'))) && (REQUEST_POST('pass1') == REQUEST_POST('pass2'))) {
	// Add admin when not added already
	if (REGISTER_ADMIN(REQUEST_POST('login'), generateHash(REQUEST_POST('pass1')), REQUEST_POST('email')) == "done") {
		// Do not ouput any form!
		$FORM = false;

		// Admin login saved
		LOAD_TEMPLATE("admin_settings_saved", false, getMessage('ADMIN_ADMINS_ADD_DONE'));

		// Run filter chain
		runFilterChain('post_admin_added', REQUEST_POST_ARRAY());
	} // END - if
} // END - if

// Shall we display the form?
if ($FORM === true) {
	// Set missing elements
	// @TODO Do we still need this ugly code here?
	if (!REQUEST_ISSET_POST(('login'))) REQUEST_SET_POST('login', "");
	if (!REQUEST_ISSET_POST(('email'))) REQUEST_SET_POST('email', "");

	// Load form from template
	LOAD_TEMPLATE("admin_admins_add");
} // END - if

//
?>
