<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/22/2005 *
 * ================                             Last change: 10/22/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_beg.php                                *
 * -------------------------------------------------------------------- *
 * Short description : List members in begging-rallye                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder in Bettel-Rallye auflisten            *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", __FILE__);

if (getConfig('beg_rallye') == "Y") {
	// Shall I withdraw now?
	if (REQUEST_ISSET_POST(('withdraw'))) {
		// Okay, let's prepare...
		$curr = date("m", time()) - 1;
		if (strlen($curr) == 1) $curr = "0".$curr;
		UPDATE_CONFIG("last_month", $curr);
		LOAD_TEMPLATE("admin_settings_saved", false, getMessage('ADMIN_BEG_WITHDRAW_PREPARED'));
	} // END - if

	// Autopurge installed?
	$lastOnline = "%s"; $ONLINE = "";
	if (EXT_IS_ACTIVE("autopurge")) {
		// Use last online timestamp to keep inactive members away from here
		$lastOnline   = " AND last_online >= (UNIX_TIMESTAMP() - %s)";
		$ONLINE = getConfig('ap_inactive_since');
	} // END - if

	// Check if at least one is in the active rallye
	$result = SQL_QUERY_ESC("SELECT userid, email, gender, surname, family, beg_points, last_online
FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE `status`='CONFIRMED' AND beg_points > 0".$lastOnline."
ORDER BY beg_points DESC, last_online DESC, userid",
	 array($ONLINE), __FILE__, __LINE__);

	if (SQL_NUMROWS($result) > 0) {
		// List users
		$OUT = "";$SW = 2; $cnt = 1; $total = 0;
		while (list($uid, $email, $gender, $sname, $fname, $turbo, $last) = SQL_FETCHROW($result)) {
			// Init variables
			$WIN1 = ""; $WIN2 = "";
			if ($cnt <= getConfig('beg_ranks')) {
				// Maybe he can win his active beg?
				$WIN1 = "<strong>";
				$WIN2 = "</strong>";
			} // END - if

			// Prepare content
			$content = array(
				'uid'    => $uid,
				'email'  => CREATE_EMAIL_LINK($email, "user_data"),
				'gender' => TRANSLATE_GENDER($gender),
				'sname'  => $sname,
				'fname'  => $fname,
				'turbo'  => TRANSLATE_COMMA($turbo),
				'last'   => MAKE_DATETIME($last, "2"),
				'sw'     => $SW,
				'win1'   => $WIN1,
				'win2'   => $WIN2,
				'cnt'    => $cnt,
			);

			// Load template and add it
			$OUT .= LOAD_TEMPLATE("admin_list_beg_rows", true, $content);
			$SW = 3 - $SW; $cnt++; $total += $turbo;
		}
		define('__BEG_ROWS', $OUT);
		define('__TOTAL', TRANSLATE_COMMA($total));

		// Check if we need to display form or not with manuel withdraw
		if (getConfig('last_month') == date("m", time())) {
			// Load form
			define('__BEG_WITHDRAW_FORM', LOAD_TEMPLATE("admin_list_beg_form", true));
		} else {
			// Display message "no manual withdraw possible"
			define('__BEG_WITHDRAW_FORM', "<div class=\"admin_failed\">{--ADMIN_BEG_ALREADY_WITHDRAW--}</div>");
		}

		// Prepare constant for timemark
		if (EXT_IS_ACTIVE("autopurge")) {
			define('__AUTOPURGE_TIMEOUT', MAKE_DATETIME(time() - getConfig('ap_inactive_since'), "2"));
		} else {
			define('__AUTOPURGE_TIMEOUT', sprintf(getMessage('EXTENSION_PROBLEM_NOT_INSTALLED'), "autopurge"));
		}

		// Load final template
		LOAD_TEMPLATE("admin_list_beg");
	} else {
		// No one has joined the begging rallye...
		LOAD_TEMPLATE("admin_settings_saved", false, getMessage('ADMIN_BEG_NO_RALLYE'));
	}
} else {
	// Rallye deactivated
	LOAD_TEMPLATE("admin_settings_saved", false, getMessage('ADMIN_BEG_RALLYE_DEACTIVATED'));
}

//
?>
