<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/24/2004 *
 * ================                             Last change: 11/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-top10.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : TOP logins / best earner etc.                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : TOP-Logins / Bestverdiener usw.                  *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif ((!EXT_IS_ACTIVE("top10")) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), "top10");
	return;
}

// Add description as navigation point
ADD_DESCR("guest", __FILE__);

//// TOP logins
$result = SQL_QUERY_ESC("
SELECT
	userid, total_logins, last_online
FROM
	{!_MYSQL_PREFIX!}_user_data
WHERE
	total_logins > 0 AND
	`status`='CONFIRMED'
ORDER BY
	total_logins DESC
LIMIT %s",
	array(getConfig('top10_max')), __FILE__, __LINE__);

$OUT = ""; $SW = 2; $cnt = 1;
while (list($uid, $logins, $last) = SQL_FETCHROW($result)) {
	$nick2 = "---";

	// Get nickname
	if (EXT_IS_ACTIVE("nickname")) $nick2 = NICKNAME_GET_NICK($uid);

	// Prepare data for template
	$content = array(
		'sw'     => $SW,
		'cnt'    => $cnt,
		'uid'    => $uid,
		'nick'   => $nick2,
		'logins' => $logins,
		'points' => TRANSLATE_COMMA(GET_TOTAL_DATA($uid, "user_points", "points")),
		'last'   => MAKE_DATETIME($last, "3"),
	);

	// Load row template
	$OUT .= LOAD_TEMPLATE("guest_top10_row_login", true, $content);

	// Switch colors and count one up
	$SW = 3 - $SW; $cnt++;
}

if ($cnt < getConfig('top10_max')) {
	// Add more "blank" rows
	for ($i = $cnt; $i <= getConfig('top10_max'); $i++) {
		// Prepare data for template
		$content = array(
			'sw'  => $SW,
			'idx' => $i
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE("guest_top10_empty5", true, $content);
		$SW = 3 - $SW;
	}
}
define('__TOP_LOGINS_ROWS', $OUT);

// Free result
SQL_FREERESULT($result);

//// TOP earners
$result = SQL_QUERY_ESC("
SELECT DISTINCT
	d.userid,
	(SUM(p.points) - d.used_points) AS tpoints,
	d.last_online
FROM
	`{!_MYSQL_PREFIX!}_user_data` AS d
LEFT JOIN
	{!_MYSQL_PREFIX!}_user_points AS p
ON
	p.userid=d.userid
WHERE
	p.points > 0 AND
	d.`status`='CONFIRMED'
GROUP BY
	p.userid
ORDER BY
	tpoints DESC,
	d.last_online DESC
LIMIT %s",
	array(getConfig('top10_max')), __FILE__, __LINE__);

$OUT = ""; $SW = 2; $cnt = 1;
while (list($uid, $points, $last) = SQL_FETCHROW($result)) {
	$nick2 = "---";

	// Get nickname
	if (EXT_IS_ACTIVE("nickname")) $nick2 = NICKNAME_GET_NICK($uid);

	// Prepare data for template
	$content = array(
		'sw'     => $SW,
		'cnt'    => $cnt,
		'uid'    => bigintval($uid),
		'nick'   => $nick2,
		'points' => TRANSLATE_COMMA($points),
		'last'   => MAKE_DATETIME($last, "3")
	);

	// Load row template
	$OUT .= LOAD_TEMPLATE("guest_top10_row_earner", true, $content);

	// Switch colors and count one up
	$SW = 3 - $SW; $cnt++;
}

if ($cnt < getConfig('top10_max')) {
	// Add more "blank" rows
	for ($i = $cnt; $i <= getConfig('top10_max'); $i++) {
		// Prepare data for template
		$content = array(
			'sw'  => $SW,
			'idx' => $i
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE("guest_top10_empty4", true, $content);
		$SW = 3 - $SW;
	}
}
define('__TOP_POINTS_ROWS', $OUT);

// Free result
SQL_FREERESULT($result);

//// TOP referal "hunter"
$result = SQL_QUERY_ESC("
SELECT DISTINCT
	d.userid,
	SUM(r.counter) AS refs,
	d.last_online
FROM
	`{!_MYSQL_PREFIX!}_user_data` AS d
LEFT JOIN
	{!_MYSQL_PREFIX!}_refsystem AS r
ON
	r.userid=d.userid
WHERE
	r.counter > 0 AND
	d.`status`='CONFIRMED'
GROUP BY
	r.userid
ORDER BY
	refs DESC,
	d.last_online DESC
LIMIT %s",
	array(getConfig('top10_max')), __FILE__, __LINE__);

$OUT = ""; $SW = 2; $cnt = 1;
while (list($uid, $refs, $last) = SQL_FETCHROW($result)) {
	$nick2 = "---";

	// Get nickname
	if (EXT_IS_ACTIVE("nickname")) $nick2 = NICKNAME_GET_NICK($uid);

	// Prepare data for template
	$content = array(
		'sw'     => $SW,
		'cnt'    => $cnt,
		'uid'    => bigintval($uid),
		'refs'   => $refs,
		'nick'   => $nick2,
		'points' => TRANSLATE_COMMA(GET_TOTAL_DATA($uid, "user_points", "points")),
		'last'   => MAKE_DATETIME($last, "3")
	);

	// Load row template
	$OUT .= LOAD_TEMPLATE("guest_top10_row_refs", true, $content);

	// Switch colors and count one up
	$SW = 3 - $SW; $cnt++;
}

if ($cnt < getConfig('top10_max')) {
	// Add more "blank" rows
	for ($i = $cnt; $i <= getConfig('top10_max'); $i++) {
		// Prepare data for template
		$content = array(
			'sw'  => $SW,
			'idx' => $i
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE("guest_top10_empty5", true, $content);
		$SW = 3 - $SW;
	}
}
define('__TOP_REFERRAL_ROWS', $OUT);

// Free result
SQL_FREERESULT($result);

// Remember other values in constants
define('__TOP10_MAX', getConfig('top10_max'));

// Load final template
LOAD_TEMPLATE("guest_top10");

//
?>
